package core

import (
	"gitea.pena/PenaSide/discount/internal/models"
)

type DiscountOptional struct {
	Name        *string
	Layer       *uint32
	Description *string
	Condition   *models.DiscountCondition
	Target      *models.DiscountCalculationTarget
	Deprecated  *bool
}

type DiscountConditions struct {
	Common    CommonDiscountCondition    `json:"common"`
	Optionals []OptionalDiscounCondition `json:"optionals"`
}

type CommonDiscountCondition struct {
	Period              models.PeriodCondition `json:"period"`
	User                string                 `json:"user"`
	UserType            string                 `json:"userType"`
	Coupon              *string                `json:"coupon"`
	PurchasesAmount     uint64                 `json:"purchasesAmount"`
	CartPurchasesAmount uint64                 `json:"cartPurchasesAmount"`
}

type OptionalDiscounCondition struct {
	Product   *string `json:"product"`
	Group     *string `json:"group"`
	PriceFrom *uint64 `json:"priceFrom"`

	/* Срок использования (количество дней использования) */
	Term *uint64 `json:"term"`

	/* Количество использований (количество попыток) */
	Usage *uint64 `json:"usage"`
}
