package fields

import "fmt"

var Discount = struct {
	ID          string
	Name        string
	Description string
	Target      string
	Condition   string
	Layer       string
	Deprecated  string
	Audit       string
}{
	ID:          "_id",
	Name:        "name",
	Description: "description",
	Target:      "target",
	Condition:   "condition",
	Layer:       "layer",
	Deprecated:  "deprecated",
	Audit:       "audit",
}

var DiscountTarget = struct {
	Products    string
	Factor      string
	TargetScope string
	TargetGroup string
	Overhelm    string
}{
	Products:    fmt.Sprintf("%s.products", Discount.Target),
	Factor:      fmt.Sprintf("%s.factor", Discount.Target),
	TargetScope: fmt.Sprintf("%s.scope", Discount.Target),
	TargetGroup: fmt.Sprintf("%s.group", Discount.Target),
	Overhelm:    fmt.Sprintf("%s.overhelm", Discount.Target),
}

var DiscountCondition = struct {
	Period              string
	Product             string
	Term                string
	Usage               string
	PriceFrom           string
	Group               string
	User                string
	UserType            string
	Coupon              string
	PurchasesAmount     string
	CartPurchasesAmount string
}{
	Period:              fmt.Sprintf("%s.period", Discount.Condition),
	Product:             fmt.Sprintf("%s.product", Discount.Condition),
	Term:                fmt.Sprintf("%s.term", Discount.Condition),
	Usage:               fmt.Sprintf("%s.usage", Discount.Condition),
	PriceFrom:           fmt.Sprintf("%s.priceFrom", Discount.Condition),
	Group:               fmt.Sprintf("%s.group", Discount.Condition),
	User:                fmt.Sprintf("%s.user", Discount.Condition),
	UserType:            fmt.Sprintf("%s.userType", Discount.Condition),
	Coupon:              fmt.Sprintf("%s.coupon", Discount.Condition),
	PurchasesAmount:     fmt.Sprintf("%s.purchasesAmount", Discount.Condition),
	CartPurchasesAmount: fmt.Sprintf("%s.cartPurchasesAmount", Discount.Condition),
}

var PeriodCondition = struct {
	From string
	To   string
}{
	From: fmt.Sprintf("%s.from", DiscountCondition.Period),
	To:   fmt.Sprintf("%s.to", DiscountCondition.Period),
}
