package initialize

import (
	"github.com/sirupsen/logrus"
	"gitea.pena/PenaSide/discount/internal/controller"
)

type ControllersDeps struct {
	Logger   *logrus.Logger
	Services *Services
}

type Controllers struct {
	DiscountController *controller.DiscountController
}

func NewControllers(deps *ControllersDeps) *Controllers {
	return &Controllers{
		DiscountController: controller.NewDiscountController(&controller.DiscountControllerDeps{
			Logger:          deps.Logger,
			DiscountService: deps.Services.DiscountService,
		}),
	}
}
