package initialize

import (
	"github.com/sirupsen/logrus"
	"gitea.pena/PenaSide/discount/internal/service"
)

type ServicesDeps struct {
	Logger       *logrus.Logger
	Repositories *Repositories
}

type Services struct {
	DiscountService *service.DiscountService
}

func NewServices(deps *ServicesDeps) *Services {
	return &Services{
		DiscountService: service.NewDiscountService(&service.DiscountServiceDeps{
			Logger:             deps.Logger,
			DiscountRepository: deps.Repositories.DiscountRepository,
		}),
	}
}
