package models

import "time"

type Audit struct {
	UpdatedAt time.Time  `json:"updatedAt" bson:"updatedAt"`
	DeletedAt *time.Time `json:"deletedAt,omitempty" bson:"deletedAt,omitempty"`
	CreatedAt time.Time  `json:"createdAt" bson:"createdAt"`
	Deleted   bool       `json:"deleted" bson:"deleted"`
}

func (receiver *Audit) Sanitize() *Audit {
	now := time.Now()

	receiver.CreatedAt = now
	receiver.UpdatedAt = now
	receiver.DeletedAt = nil
	receiver.Deleted = false

	return receiver
}
