package utils

import (
	"gitea.pena/PenaSide/discount/internal/models"
)

func FilterCouponDiscounts(discounts []models.Discount) ([]models.Discount, *models.Discount) {
	if len(discounts) == 0 {
		return []models.Discount{}, nil
	}

	var couponDiscount *models.Discount

	notCouponDiscount := make([]models.Discount, 0, len(discounts))

	for _, discount := range discounts {
		isCouponDiscount := discount.Condition.Coupon != nil && *discount.Condition.Coupon != ""
		currentDiscount := discount

		if isCouponDiscount && couponDiscount != nil {
			continue
		}

		if isCouponDiscount && couponDiscount == nil {
			couponDiscount = &currentDiscount
		}

		notCouponDiscount = append(notCouponDiscount, discount)
	}

	return notCouponDiscount, couponDiscount
}
