package transfer

import (
	"gitea.pena/PenaSide/discount/internal/models"
	proto "gitea.pena/PenaSide/discount/internal/proto/discount"
	"gitea.pena/PenaSide/discount/pkg/defaults"
)

func DiscountCalculationTargetProtoToModel(discountTarget *proto.DiscountCalculationTarget) *models.DiscountCalculationTarget {
	if discountTarget == nil {
		return &models.DiscountCalculationTarget{TargetScope: models.TargetSum}
	}

	return &models.DiscountCalculationTarget{
		Products:    ProductTargetsProtoToModel(discountTarget.Products),
		Factor:      discountTarget.Factor,
		TargetScope: models.TargetScopeModelMap[defaults.GetDefaultValue(discountTarget.TargetScope, 0)],
		TargetGroup: defaults.GetDefaultValue(discountTarget.TargetGroup, ""),
		Overhelm:    defaults.GetDefaultValue(discountTarget.Overhelm, false),
	}
}

func DiscountCalculationTargetModelToProto(discountTarget models.DiscountCalculationTarget) *proto.DiscountCalculationTarget {
	scope := models.TargetScopeProtoMap[discountTarget.TargetScope]

	return &proto.DiscountCalculationTarget{
		Products:    ProductTargetsModelToProto(discountTarget.Products),
		Factor:      discountTarget.Factor,
		TargetScope: &scope,
		TargetGroup: &discountTarget.TargetGroup,
		Overhelm:    &discountTarget.Overhelm,
	}
}
