package transfer

import (
	"gitea.pena/PenaSide/discount/internal/models"
	proto "gitea.pena/PenaSide/discount/internal/proto/discount"
)

func DiscountConditionModelToProto(discountCondition *models.DiscountCondition) *proto.DiscountCondition {
	if discountCondition == nil {
		return nil
	}

	return &proto.DiscountCondition{
		Period:              PeriodModelToProto(discountCondition.Period),
		User:                discountCondition.User,
		UserType:            discountCondition.UserType,
		Coupon:              discountCondition.Coupon,
		PurchasesAmount:     discountCondition.PurchasesAmount,
		CartPurchasesAmount: discountCondition.CartPurchasesAmount,
		Term:                discountCondition.Term,
		Product:             discountCondition.Product,
		Usage:               discountCondition.Usage,
		PriceFrom:           discountCondition.PriceFrom,
		Group:               discountCondition.Group,
	}
}

func DiscountConditionProtoToModel(discountCondition *proto.DiscountCondition) *models.DiscountCondition {
	if discountCondition == nil {
		return &models.DiscountCondition{}
	}

	return &models.DiscountCondition{
		Period:              PeriodProtoToModel(discountCondition.GetPeriod()),
		Product:             discountCondition.Product,
		User:                discountCondition.User,
		UserType:            discountCondition.UserType,
		Coupon:              discountCondition.Coupon,
		PurchasesAmount:     discountCondition.PurchasesAmount,
		CartPurchasesAmount: discountCondition.CartPurchasesAmount,
		Term:                discountCondition.Term,
		Usage:               discountCondition.Usage,
		PriceFrom:           discountCondition.PriceFrom,
		Group:               discountCondition.Group,
	}
}
