package transfer

import (
	"google.golang.org/protobuf/types/known/timestamppb"
	"gitea.pena/PenaSide/discount/internal/models"
	proto "gitea.pena/PenaSide/discount/internal/proto/discount"
)

func PeriodModelToProto(perion *models.PeriodCondition) *proto.PeriodCondition {
	if perion == nil {
		return nil
	}

	return &proto.PeriodCondition{
		From: timestamppb.New(perion.From),
		To:   timestamppb.New(perion.To),
	}
}

func PeriodProtoToModel(perion *proto.PeriodCondition) *models.PeriodCondition {
	if perion == nil {
		return nil
	}

	return &models.PeriodCondition{
		From: perion.GetFrom().AsTime(),
		To:   perion.GetTo().AsTime(),
	}
}
