package defaults_test

import (
	"testing"

	"github.com/stretchr/testify/assert"
	"gitea.pena/PenaSide/discount/pkg/defaults"
)

func TestGetDefaultValue(t *testing.T) {
	t.Run("Стандартное значение nil", func(t *testing.T) {
		assert.Equal(t, 0, defaults.GetDefaultValue(nil, 0))
	})

	t.Run("Стандартное значение float64", func(t *testing.T) {
		assert.Equal(t, float64(0), defaults.GetDefaultValue(nil, float64(0)))
	})

	t.Run("Стандартное значение строки", func(t *testing.T) {
		testString := "test"

		assert.Equal(t, "test", defaults.GetDefaultValue(&testString, ""))
	})
}
